// >>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
// ------------------------------------------------------------------
// Copyright (c) 2019-2020 by Lattice Semiconductor Corporation
// ALL RIGHTS RESERVED
// ------------------------------------------------------------------
//
// IMPORTANT: THIS FILE IS USED BY OR GENERATED BY the LATTICE PROPEL
// DEVELOPMENT SUITE, WHICH INCLUDES PROPEL BUILDER AND PROPEL SDK.
//
// Lattice grants permission to use this code pursuant to the
// terms of the Lattice Propel License Agreement.
//
// DISCLAIMER:
//
//  LATTICE MAKES NO WARRANTIES ON THIS FILE OR ITS CONTENTS, WHETHER
//  EXPRESSED, IMPLIED, STATUTORY, OR IN ANY PROVISION OF THE LATTICE
//  PROPEL LICENSE AGREEMENT OR COMMUNICATION WITH LICENSEE, AND LATTICE
//  SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF MERCHANTABILITY OR
//  FITNESS FOR A PARTICULAR PURPOSE.  LATTICE DOES NOT WARRANT THAT THE
//  FUNCTIONS CONTAINED HEREIN WILL MEET LICENSEE'S REQUIREMENTS, OR THAT
//  LICENSEE'S OPERATION OF ANY DEVICE, SOFTWARE OR SYSTEM USING THIS FILE
//  OR ITS CONTENTS WILL BE UNINTERRUPTED OR ERROR FREE, OR THAT DEFECTS
//  HEREIN WILL BE CORRECTED.  LICENSEE ASSUMES RESPONSIBILITY FOR 
//  SELECTION OF MATERIALS TO ACHIEVE ITS INTENDED RESULTS, AND FOR THE
//  PROPER INSTALLATION, USE, AND RESULTS OBTAINED THEREFROM.  LICENSEE
//  ASSUMES THE ENTIRE RISK OF THE FILE AND ITS CONTENTS PROVING DEFECTIVE
//  OR FAILING TO PERFORM PROPERLY AND IN SUCH EVENT, LICENSEE SHALL
//  ASSUME THE ENTIRE COST AND RISK OF ANY REPAIR, SERVICE, CORRECTION, OR
//  ANY OTHER LIABILITIES OR DAMAGES CAUSED BY OR ASSOCIATED WITH THE
//  SOFTWARE.  IN NO EVENT SHALL LATTICE BE LIABLE TO ANY PARTY FOR DIRECT,
//  INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES, INCLUDING LOST
//  PROFITS, ARISING OUT OF THE USE OF THIS FILE OR ITS CONTENTS, EVEN IF
//  LATTICE HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. LATTICE'S
//  SOLE LIABILITY, AND LICENSEE'S SOLE REMEDY, IS SET FORTH ABOVE. 
//  LATTICE DOES NOT WARRANT OR REPRESENT THAT THIS FILE, ITS CONTENTS OR
//  USE THEREOF DOES NOT INFRINGE ON THIRD PARTIES' INTELLECTUAL PROPERTY
//  RIGHTS, INCLUDING ANY PATENT. IT IS THE USER'S RESPONSIBILITY TO VERIFY
//  THE USER SOFTWARE DESIGN FOR CONSISTENCY AND FUNCTIONALITY THROUGH THE
//  USE OF FORMAL SOFTWARE VALIDATION METHODS.
// ------------------------------------------------------------------

/* synthesis translate_off*/
`define SBP_SIMULATION
/* synthesis translate_on*/
`ifndef SBP_SIMULATION
`define SBP_SYNTHESIS
`endif

`include "./lib/latticesemi.com/ip/cpu0/2.1.1/rtl/cpu0.v"
`include "./lib/latticesemi.com/ip/gpio0/1.6.0/rtl/gpio0.v"
`include "./lib/latticesemi.com/ip/sysmem0/1.0.4/rtl/sysmem0.v"
`include "./lib/latticesemi.com/ip/uart0/1.3.0/rtl/uart0.v"
`include "./lib/latticesemi.com/module/ahbl0/1.3.0/rtl/ahbl0.v"
`include "./lib/latticesemi.com/module/ahbl2apb0/1.1.0/rtl/ahbl2apb0.v"
`include "./lib/latticesemi.com/module/apb0/1.1.0/rtl/apb0.v"
`include "./lib/latticesemi.com/module/osc0/1.2.0/rtl/osc0.v"
`include "./lib/latticesemi.com/module/pll0/1.5.0/rtl/pll0.v"


//
// Verific Verilog Description of module test_certus
//
module test_certus (led_o, rstn_i, rxd_i, txd_o) /* synthesis sbp_module=true */ ;
    inout [7:0]led_o;
    input rstn_i;
    input rxd_i;
    output txd_o;
    
    wire [31:0]ahbl0_inst_AHBL_M00_interconnect_HADDR_interconnect;
    wire [2:0]ahbl0_inst_AHBL_M00_interconnect_HBURST_interconnect;
    wire [3:0]ahbl0_inst_AHBL_M00_interconnect_HPROT_interconnect;
    wire [31:0]ahbl0_inst_AHBL_M00_interconnect_HRDATA_interconnect;
    wire [2:0]ahbl0_inst_AHBL_M00_interconnect_HSIZE_interconnect;
    wire [1:0]ahbl0_inst_AHBL_M00_interconnect_HTRANS_interconnect;
    wire [31:0]ahbl0_inst_AHBL_M00_interconnect_HWDATA_interconnect;
    wire [31:0]ahbl0_inst_AHBL_M01_interconnect_HADDR_interconnect;
    wire [2:0]ahbl0_inst_AHBL_M01_interconnect_HBURST_interconnect;
    wire [3:0]ahbl0_inst_AHBL_M01_interconnect_HPROT_interconnect;
    wire [31:0]ahbl0_inst_AHBL_M01_interconnect_HRDATA_interconnect;
    wire [2:0]ahbl0_inst_AHBL_M01_interconnect_HSIZE_interconnect;
    wire [1:0]ahbl0_inst_AHBL_M01_interconnect_HTRANS_interconnect;
    wire [31:0]ahbl0_inst_AHBL_M01_interconnect_HWDATA_interconnect;
    wire [31:0]cpu0_inst_AHBL_M1_DATA_interconnect_HADDR_interconnect;
    wire [2:0]cpu0_inst_AHBL_M1_DATA_interconnect_HBURST_interconnect;
    wire [3:0]cpu0_inst_AHBL_M1_DATA_interconnect_HPROT_interconnect;
    wire [31:0]cpu0_inst_AHBL_M1_DATA_interconnect_HRDATA_interconnect;
    wire [2:0]cpu0_inst_AHBL_M1_DATA_interconnect_HSIZE_interconnect;
    wire [1:0]cpu0_inst_AHBL_M1_DATA_interconnect_HTRANS_interconnect;
    wire [31:0]cpu0_inst_AHBL_M1_DATA_interconnect_HWDATA_interconnect;
    
    wire pll0_inst_clkop_o_net, cpu0_inst_system_resetn_o_net, ahbl0_inst_AHBL_M00_interconnect_HMASTLOCK_interconnect, 
        ahbl0_inst_AHBL_M00_interconnect_HREADYOUT_interconnect, ahbl0_inst_AHBL_M00_interconnect_HREADY_interconnect, 
        ahbl0_inst_AHBL_M00_interconnect_HRESP_interconnect, ahbl0_inst_AHBL_M00_interconnect_HSELx_interconnect, 
        ahbl0_inst_AHBL_M00_interconnect_HWRITE_interconnect, ahbl0_inst_AHBL_M01_interconnect_HMASTLOCK_interconnect, 
        ahbl0_inst_AHBL_M01_interconnect_HREADYOUT_interconnect, ahbl0_inst_AHBL_M01_interconnect_HREADY_interconnect, 
        ahbl0_inst_AHBL_M01_interconnect_HRESP_interconnect, ahbl0_inst_AHBL_M01_interconnect_HSELx_interconnect, 
        ahbl0_inst_AHBL_M01_interconnect_HWRITE_interconnect, cpu0_inst_AHBL_M1_DATA_interconnect_HMASTLOCK_interconnect, 
        cpu0_inst_AHBL_M1_DATA_interconnect_HREADYOUT_interconnect, cpu0_inst_AHBL_M1_DATA_interconnect_HRESP_interconnect, 
        cpu0_inst_AHBL_M1_DATA_interconnect_HWRITE_interconnect;
    wire [31:0]ahbl2apb0_inst_APB_M0_interconnect_PADDR_interconnect;
    wire [31:0]ahbl2apb0_inst_APB_M0_interconnect_PRDATA_interconnect;
    wire [31:0]ahbl2apb0_inst_APB_M0_interconnect_PWDATA_interconnect;
    
    wire ahbl2apb0_inst_APB_M0_interconnect_PENABLE_interconnect, ahbl2apb0_inst_APB_M0_interconnect_PREADY_interconnect, 
        ahbl2apb0_inst_APB_M0_interconnect_PSELx_interconnect, ahbl2apb0_inst_APB_M0_interconnect_PSLVERR_interconnect, 
        ahbl2apb0_inst_APB_M0_interconnect_PWRITE_interconnect, pll0_inst_clkos_o_net;
    wire [31:0]apb0_inst_APB_M00_interconnect_PADDR_interconnect;
    wire [31:0]apb0_inst_APB_M00_interconnect_PRDATA_interconnect;
    wire [31:0]apb0_inst_APB_M00_interconnect_PWDATA_interconnect;
    wire [31:0]apb0_inst_APB_M01_interconnect_PADDR_interconnect;
    wire [31:0]apb0_inst_APB_M01_interconnect_PRDATA_interconnect;
    wire [31:0]apb0_inst_APB_M01_interconnect_PWDATA_interconnect;
    
    wire apb0_inst_APB_M00_interconnect_PENABLE_interconnect, apb0_inst_APB_M00_interconnect_PREADY_interconnect, 
        apb0_inst_APB_M00_interconnect_PSELx_interconnect, apb0_inst_APB_M00_interconnect_PSLVERR_interconnect, 
        apb0_inst_APB_M00_interconnect_PWRITE_interconnect, apb0_inst_APB_M01_interconnect_PENABLE_interconnect, 
        apb0_inst_APB_M01_interconnect_PREADY_interconnect, apb0_inst_APB_M01_interconnect_PSELx_interconnect, 
        apb0_inst_APB_M01_interconnect_PSLVERR_interconnect, apb0_inst_APB_M01_interconnect_PWRITE_interconnect;
    wire [31:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HADDR_interconnect;
    wire [2:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HBURST_interconnect;
    wire [3:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HPROT_interconnect;
    wire [31:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HRDATA_interconnect;
    wire [2:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HSIZE_interconnect;
    wire [1:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HTRANS_interconnect;
    wire [31:0]cpu0_inst_AHBL_M0_INSTR_interconnect_HWDATA_interconnect;
    
    wire cpu0_inst_AHBL_M0_INSTR_interconnect_HMASTLOCK_interconnect, cpu0_inst_AHBL_M0_INSTR_interconnect_HREADYOUT_interconnect, 
        cpu0_inst_AHBL_M0_INSTR_interconnect_HRESP_interconnect, cpu0_inst_AHBL_M0_INSTR_interconnect_HWRITE_interconnect, 
        uart0_inst_INT_M0_interconnect_IRQ_interconnect, gpio0_inst_INTR_interconnect_IRQ_interconnect, 
        equation_module0_inst_O_net, osc0_inst_hf_clk_out_o_net, pll0_inst_lock_o_net;
    
    
    assign equation_module0_inst_O_net = (rstn_i & pll0_inst_lock_o_net) ; 
ahbl0 ahbl0_inst (.ahbl_m00_haddr_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HADDR_interconnect}), 
            .ahbl_m00_hburst_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HBURST_interconnect}), 
            .ahbl_m00_hprot_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HPROT_interconnect}), 
            .ahbl_m00_hrdata_mstr_i({ahbl0_inst_AHBL_M00_interconnect_HRDATA_interconnect}), 
            .ahbl_m00_hsize_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HSIZE_interconnect}), 
            .ahbl_m00_htrans_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HTRANS_interconnect}), 
            .ahbl_m00_hwdata_mstr_o({ahbl0_inst_AHBL_M00_interconnect_HWDATA_interconnect}), 
            .ahbl_m01_haddr_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HADDR_interconnect}), 
            .ahbl_m01_hburst_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HBURST_interconnect}), 
            .ahbl_m01_hprot_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HPROT_interconnect}), 
            .ahbl_m01_hrdata_mstr_i({ahbl0_inst_AHBL_M01_interconnect_HRDATA_interconnect}), 
            .ahbl_m01_hsize_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HSIZE_interconnect}), 
            .ahbl_m01_htrans_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HTRANS_interconnect}), 
            .ahbl_m01_hwdata_mstr_o({ahbl0_inst_AHBL_M01_interconnect_HWDATA_interconnect}), 
            .ahbl_s00_haddr_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HADDR_interconnect}), 
            .ahbl_s00_hburst_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HBURST_interconnect}), 
            .ahbl_s00_hprot_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HPROT_interconnect}), 
            .ahbl_s00_hrdata_slv_o({cpu0_inst_AHBL_M1_DATA_interconnect_HRDATA_interconnect}), 
            .ahbl_s00_hsize_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HSIZE_interconnect}), 
            .ahbl_s00_htrans_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HTRANS_interconnect}), 
            .ahbl_s00_hwdata_slv_i({cpu0_inst_AHBL_M1_DATA_interconnect_HWDATA_interconnect}), 
            .ahbl_hclk_i(pll0_inst_clkop_o_net), .ahbl_hresetn_i(cpu0_inst_system_resetn_o_net), 
            .ahbl_m00_hmastlock_mstr_o(ahbl0_inst_AHBL_M00_interconnect_HMASTLOCK_interconnect), 
            .ahbl_m00_hready_mstr_i(ahbl0_inst_AHBL_M00_interconnect_HREADYOUT_interconnect), 
            .ahbl_m00_hready_mstr_o(ahbl0_inst_AHBL_M00_interconnect_HREADY_interconnect), 
            .ahbl_m00_hresp_mstr_i(ahbl0_inst_AHBL_M00_interconnect_HRESP_interconnect), 
            .ahbl_m00_hsel_mstr_o(ahbl0_inst_AHBL_M00_interconnect_HSELx_interconnect), 
            .ahbl_m00_hwrite_mstr_o(ahbl0_inst_AHBL_M00_interconnect_HWRITE_interconnect), 
            .ahbl_m01_hmastlock_mstr_o(ahbl0_inst_AHBL_M01_interconnect_HMASTLOCK_interconnect), 
            .ahbl_m01_hready_mstr_i(ahbl0_inst_AHBL_M01_interconnect_HREADYOUT_interconnect), 
            .ahbl_m01_hready_mstr_o(ahbl0_inst_AHBL_M01_interconnect_HREADY_interconnect), 
            .ahbl_m01_hresp_mstr_i(ahbl0_inst_AHBL_M01_interconnect_HRESP_interconnect), 
            .ahbl_m01_hsel_mstr_o(ahbl0_inst_AHBL_M01_interconnect_HSELx_interconnect), 
            .ahbl_m01_hwrite_mstr_o(ahbl0_inst_AHBL_M01_interconnect_HWRITE_interconnect), 
            .ahbl_s00_hmastlock_slv_i(cpu0_inst_AHBL_M1_DATA_interconnect_HMASTLOCK_interconnect), 
            .ahbl_s00_hready_slv_i(cpu0_inst_AHBL_M1_DATA_interconnect_HREADYOUT_interconnect), 
            .ahbl_s00_hreadyout_slv_o(cpu0_inst_AHBL_M1_DATA_interconnect_HREADYOUT_interconnect), 
            .ahbl_s00_hresp_slv_o(cpu0_inst_AHBL_M1_DATA_interconnect_HRESP_interconnect), 
            .ahbl_s00_hsel_slv_i(1'b1), .ahbl_s00_hwrite_slv_i(cpu0_inst_AHBL_M1_DATA_interconnect_HWRITE_interconnect));
    defparam ahbl0_inst.FULL_DECODE_EN = 1;
    defparam ahbl0_inst.M0_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M0_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M10_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M11_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M12_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M13_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M14_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M15_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M16_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M17_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M18_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M19_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M1_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M20_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M21_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M22_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M23_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M24_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M25_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M26_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M27_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M28_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M29_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M2_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M30_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M31_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M3_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M4_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M5_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M6_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M7_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M8_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S0_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S10_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S11_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S12_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S13_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S14_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S15_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S16_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S17_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S18_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S19_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S1_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S20_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S21_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S22_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S23_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S24_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S25_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S26_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S27_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S28_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S29_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S2_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S30_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S31_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S3_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S4_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S5_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S6_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S7_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S8_CONNECT_EN = 1;
    defparam ahbl0_inst.M9_S9_CONNECT_EN = 1;
    defparam ahbl0_inst.M_ADDR_WIDTH = 32;
    defparam ahbl0_inst.S0_ADDR_RANGE = 32'h00008000;
    defparam ahbl0_inst.S0_BASE_ADDR = 32'h00000000;
    defparam ahbl0_inst.S0_FRAGMENT_EN = 1;
    defparam ahbl0_inst.S1_ADDR_RANGE = 32'h00000800;
    defparam ahbl0_inst.S1_BASE_ADDR = 32'h00008000;
    defparam ahbl0_inst.S1_FRAGMENT_EN = 1;
    ahbl2apb0 ahbl2apb0_inst (.ahbl_haddr_i({ahbl0_inst_AHBL_M01_interconnect_HADDR_interconnect}), 
            .ahbl_hburst_i({ahbl0_inst_AHBL_M01_interconnect_HBURST_interconnect}), 
            .ahbl_hprot_i({ahbl0_inst_AHBL_M01_interconnect_HPROT_interconnect}), 
            .ahbl_hrdata_o({ahbl0_inst_AHBL_M01_interconnect_HRDATA_interconnect}), 
            .ahbl_hsize_i({ahbl0_inst_AHBL_M01_interconnect_HSIZE_interconnect}), 
            .ahbl_htrans_i({ahbl0_inst_AHBL_M01_interconnect_HTRANS_interconnect}), 
            .ahbl_hwdata_i({ahbl0_inst_AHBL_M01_interconnect_HWDATA_interconnect}), 
            .apb_paddr_o({ahbl2apb0_inst_APB_M0_interconnect_PADDR_interconnect}), 
            .apb_prdata_i({ahbl2apb0_inst_APB_M0_interconnect_PRDATA_interconnect}), 
            .apb_pwdata_o({ahbl2apb0_inst_APB_M0_interconnect_PWDATA_interconnect}), 
            .ahbl_hmastlock_i(ahbl0_inst_AHBL_M01_interconnect_HMASTLOCK_interconnect), 
            .ahbl_hready_i(ahbl0_inst_AHBL_M01_interconnect_HREADY_interconnect), 
            .ahbl_hreadyout_o(ahbl0_inst_AHBL_M01_interconnect_HREADYOUT_interconnect), 
            .ahbl_hresp_o(ahbl0_inst_AHBL_M01_interconnect_HRESP_interconnect), 
            .ahbl_hsel_i(ahbl0_inst_AHBL_M01_interconnect_HSELx_interconnect), 
            .ahbl_hwrite_i(ahbl0_inst_AHBL_M01_interconnect_HWRITE_interconnect), 
            .apb_penable_o(ahbl2apb0_inst_APB_M0_interconnect_PENABLE_interconnect), 
            .apb_pready_i(ahbl2apb0_inst_APB_M0_interconnect_PREADY_interconnect), 
            .apb_psel_o(ahbl2apb0_inst_APB_M0_interconnect_PSELx_interconnect), 
            .apb_pslverr_i(ahbl2apb0_inst_APB_M0_interconnect_PSLVERR_interconnect), 
            .apb_pwrite_o(ahbl2apb0_inst_APB_M0_interconnect_PWRITE_interconnect), 
            .clk_i(pll0_inst_clkop_o_net), .pclk_i(pll0_inst_clkos_o_net), 
            .presetn_i(cpu0_inst_system_resetn_o_net), .rst_n_i(cpu0_inst_system_resetn_o_net));
    defparam ahbl2apb0_inst.ADDR_WIDTH = 32;
    apb0 apb0_inst (.apb_m00_paddr_mstr_o({apb0_inst_APB_M00_interconnect_PADDR_interconnect}), 
         .apb_m00_prdata_mstr_i({apb0_inst_APB_M00_interconnect_PRDATA_interconnect}), 
         .apb_m00_pwdata_mstr_o({apb0_inst_APB_M00_interconnect_PWDATA_interconnect}), 
         .apb_m01_paddr_mstr_o({apb0_inst_APB_M01_interconnect_PADDR_interconnect}), 
         .apb_m01_prdata_mstr_i({apb0_inst_APB_M01_interconnect_PRDATA_interconnect}), 
         .apb_m01_pwdata_mstr_o({apb0_inst_APB_M01_interconnect_PWDATA_interconnect}), 
         .apb_s00_paddr_slv_i({ahbl2apb0_inst_APB_M0_interconnect_PADDR_interconnect}), 
         .apb_s00_prdata_slv_o({ahbl2apb0_inst_APB_M0_interconnect_PRDATA_interconnect}), 
         .apb_s00_pwdata_slv_i({ahbl2apb0_inst_APB_M0_interconnect_PWDATA_interconnect}), 
         .apb_m00_penable_mstr_o(apb0_inst_APB_M00_interconnect_PENABLE_interconnect), 
         .apb_m00_pready_mstr_i(apb0_inst_APB_M00_interconnect_PREADY_interconnect), 
         .apb_m00_psel_mstr_o(apb0_inst_APB_M00_interconnect_PSELx_interconnect), 
         .apb_m00_pslverr_mstr_i(apb0_inst_APB_M00_interconnect_PSLVERR_interconnect), 
         .apb_m00_pwrite_mstr_o(apb0_inst_APB_M00_interconnect_PWRITE_interconnect), 
         .apb_m01_penable_mstr_o(apb0_inst_APB_M01_interconnect_PENABLE_interconnect), 
         .apb_m01_pready_mstr_i(apb0_inst_APB_M01_interconnect_PREADY_interconnect), 
         .apb_m01_psel_mstr_o(apb0_inst_APB_M01_interconnect_PSELx_interconnect), 
         .apb_m01_pslverr_mstr_i(apb0_inst_APB_M01_interconnect_PSLVERR_interconnect), 
         .apb_m01_pwrite_mstr_o(apb0_inst_APB_M01_interconnect_PWRITE_interconnect), 
         .apb_pclk_i(pll0_inst_clkos_o_net), .apb_presetn_i(cpu0_inst_system_resetn_o_net), 
         .apb_s00_penable_slv_i(ahbl2apb0_inst_APB_M0_interconnect_PENABLE_interconnect), 
         .apb_s00_pready_slv_o(ahbl2apb0_inst_APB_M0_interconnect_PREADY_interconnect), 
         .apb_s00_psel_slv_i(ahbl2apb0_inst_APB_M0_interconnect_PSELx_interconnect), 
         .apb_s00_pslverr_slv_o(ahbl2apb0_inst_APB_M0_interconnect_PSLVERR_interconnect), 
         .apb_s00_pwrite_slv_i(ahbl2apb0_inst_APB_M0_interconnect_PWRITE_interconnect));
    defparam apb0_inst.FULL_DECODE_EN = 1;
    defparam apb0_inst.M_ADDR_WIDTH = 32;
    defparam apb0_inst.S0_ADDR_RANGE = 32'h00000400;
    defparam apb0_inst.S0_BASE_ADDR = 32'h00008000;
    defparam apb0_inst.S1_ADDR_RANGE = 32'h00000400;
    defparam apb0_inst.S1_BASE_ADDR = 32'h00008400;
    cpu0 cpu0_inst (.ahbl_m_data_haddr_o({cpu0_inst_AHBL_M1_DATA_interconnect_HADDR_interconnect}), 
         .ahbl_m_data_hburst_o({cpu0_inst_AHBL_M1_DATA_interconnect_HBURST_interconnect}), 
         .ahbl_m_data_hprot_o({cpu0_inst_AHBL_M1_DATA_interconnect_HPROT_interconnect}), 
         .ahbl_m_data_hrdata_i({cpu0_inst_AHBL_M1_DATA_interconnect_HRDATA_interconnect}), 
         .ahbl_m_data_hsize_o({cpu0_inst_AHBL_M1_DATA_interconnect_HSIZE_interconnect}), 
         .ahbl_m_data_htrans_o({cpu0_inst_AHBL_M1_DATA_interconnect_HTRANS_interconnect}), 
         .ahbl_m_data_hwdata_o({cpu0_inst_AHBL_M1_DATA_interconnect_HWDATA_interconnect}), 
         .ahbl_m_instr_haddr_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HADDR_interconnect}), 
         .ahbl_m_instr_hburst_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HBURST_interconnect}), 
         .ahbl_m_instr_hprot_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HPROT_interconnect}), 
         .ahbl_m_instr_hrdata_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HRDATA_interconnect}), 
         .ahbl_m_instr_hsize_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HSIZE_interconnect}), 
         .ahbl_m_instr_htrans_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HTRANS_interconnect}), 
         .ahbl_m_instr_hwdata_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HWDATA_interconnect}), 
         .ahbl_m_data_hmastlock_o(cpu0_inst_AHBL_M1_DATA_interconnect_HMASTLOCK_interconnect), 
         .ahbl_m_data_hready_i(cpu0_inst_AHBL_M1_DATA_interconnect_HREADYOUT_interconnect), 
         .ahbl_m_data_hresp_i(cpu0_inst_AHBL_M1_DATA_interconnect_HRESP_interconnect), 
         .ahbl_m_data_hwrite_o(cpu0_inst_AHBL_M1_DATA_interconnect_HWRITE_interconnect), 
         .ahbl_m_instr_hmastlock_o(cpu0_inst_AHBL_M0_INSTR_interconnect_HMASTLOCK_interconnect), 
         .ahbl_m_instr_hready_i(cpu0_inst_AHBL_M0_INSTR_interconnect_HREADYOUT_interconnect), 
         .ahbl_m_instr_hresp_i(cpu0_inst_AHBL_M0_INSTR_interconnect_HRESP_interconnect), 
         .ahbl_m_instr_hwrite_o(cpu0_inst_AHBL_M0_INSTR_interconnect_HWRITE_interconnect), 
         .clk_i(pll0_inst_clkop_o_net), .irq0_i(uart0_inst_INT_M0_interconnect_IRQ_interconnect), 
         .irq1_i(gpio0_inst_INTR_interconnect_IRQ_interconnect), .rst_n_i(equation_module0_inst_O_net), 
         .system_resetn_o(cpu0_inst_system_resetn_o_net));
    defparam cpu0_inst.DCACHE_ENABLE = 0;
    defparam cpu0_inst.DCACHE_RANGE_HIGH = 32'h00000000;
    defparam cpu0_inst.DCACHE_RANGE_LOW = 32'hFFFFFFFF;
    defparam cpu0_inst.ICACHE_ENABLE = 0;
    defparam cpu0_inst.ICACHE_RANGE_HIGH = 32'h00000000;
    defparam cpu0_inst.ICACHE_RANGE_LOW = 32'hFFFFFFFF;
    defparam cpu0_inst.PICTIMER_START_ADDR = 32'hFFFF0000;
    gpio0 gpio0_inst (.apb_paddr_i({apb0_inst_APB_M01_interconnect_PADDR_interconnect[5:0]}), 
          .apb_prdata_o({apb0_inst_APB_M01_interconnect_PRDATA_interconnect}), 
          .apb_pwdata_i({apb0_inst_APB_M01_interconnect_PWDATA_interconnect}), 
          .gpio_io({led_o}), .apb_penable_i(apb0_inst_APB_M01_interconnect_PENABLE_interconnect), 
          .apb_pready_o(apb0_inst_APB_M01_interconnect_PREADY_interconnect), 
          .apb_psel_i(apb0_inst_APB_M01_interconnect_PSELx_interconnect), 
          .apb_pslverr_o(apb0_inst_APB_M01_interconnect_PSLVERR_interconnect), 
          .apb_pwrite_i(apb0_inst_APB_M01_interconnect_PWRITE_interconnect), 
          .clk_i(pll0_inst_clkos_o_net), .int_o(gpio0_inst_INTR_interconnect_IRQ_interconnect), 
          .resetn_i(cpu0_inst_system_resetn_o_net));
    osc0 osc0_inst (.hf_clk_out_o(osc0_inst_hf_clk_out_o_net), .hf_out_en_i(1'b1));
    pll0 pll0_inst (.clki_i(osc0_inst_hf_clk_out_o_net), .clkop_o(pll0_inst_clkop_o_net), 
         .clkos_o(pll0_inst_clkos_o_net), .lock_o(pll0_inst_lock_o_net), 
         .rstn_i(rstn_i));
    sysmem0 sysmem0_inst (.ahbl_s0_haddr_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HADDR_interconnect}), 
            .ahbl_s0_hburst_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HBURST_interconnect}), 
            .ahbl_s0_hprot_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HPROT_interconnect}), 
            .ahbl_s0_hrdata_o({cpu0_inst_AHBL_M0_INSTR_interconnect_HRDATA_interconnect}), 
            .ahbl_s0_hsize_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HSIZE_interconnect}), 
            .ahbl_s0_htrans_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HTRANS_interconnect}), 
            .ahbl_s0_hwdata_i({cpu0_inst_AHBL_M0_INSTR_interconnect_HWDATA_interconnect}), 
            .ahbl_s1_haddr_i({ahbl0_inst_AHBL_M00_interconnect_HADDR_interconnect}), 
            .ahbl_s1_hburst_i({ahbl0_inst_AHBL_M00_interconnect_HBURST_interconnect}), 
            .ahbl_s1_hprot_i({ahbl0_inst_AHBL_M00_interconnect_HPROT_interconnect}), 
            .ahbl_s1_hrdata_o({ahbl0_inst_AHBL_M00_interconnect_HRDATA_interconnect}), 
            .ahbl_s1_hsize_i({ahbl0_inst_AHBL_M00_interconnect_HSIZE_interconnect}), 
            .ahbl_s1_htrans_i({ahbl0_inst_AHBL_M00_interconnect_HTRANS_interconnect}), 
            .ahbl_s1_hwdata_i({ahbl0_inst_AHBL_M00_interconnect_HWDATA_interconnect}), 
            .ahbl_hclk_i(pll0_inst_clkop_o_net), .ahbl_hresetn_i(cpu0_inst_system_resetn_o_net), 
            .ahbl_s0_hmastlock_i(cpu0_inst_AHBL_M0_INSTR_interconnect_HMASTLOCK_interconnect), 
            .ahbl_s0_hready_i(cpu0_inst_AHBL_M0_INSTR_interconnect_HREADYOUT_interconnect), 
            .ahbl_s0_hreadyout_o(cpu0_inst_AHBL_M0_INSTR_interconnect_HREADYOUT_interconnect), 
            .ahbl_s0_hresp_o(cpu0_inst_AHBL_M0_INSTR_interconnect_HRESP_interconnect), 
            .ahbl_s0_hsel_i(1'b1), .ahbl_s0_hwrite_i(cpu0_inst_AHBL_M0_INSTR_interconnect_HWRITE_interconnect), 
            .ahbl_s1_hmastlock_i(ahbl0_inst_AHBL_M00_interconnect_HMASTLOCK_interconnect), 
            .ahbl_s1_hready_i(ahbl0_inst_AHBL_M00_interconnect_HREADY_interconnect), 
            .ahbl_s1_hreadyout_o(ahbl0_inst_AHBL_M00_interconnect_HREADYOUT_interconnect), 
            .ahbl_s1_hresp_o(ahbl0_inst_AHBL_M00_interconnect_HRESP_interconnect), 
            .ahbl_s1_hsel_i(ahbl0_inst_AHBL_M00_interconnect_HSELx_interconnect), 
            .ahbl_s1_hwrite_i(ahbl0_inst_AHBL_M00_interconnect_HWRITE_interconnect));
    defparam sysmem0_inst.MEM_ID = "1.0.4";
    uart0 uart0_inst (.apb_paddr_i({apb0_inst_APB_M00_interconnect_PADDR_interconnect[5:0]}), 
          .apb_prdata_o({apb0_inst_APB_M00_interconnect_PRDATA_interconnect}), 
          .apb_pwdata_i({apb0_inst_APB_M00_interconnect_PWDATA_interconnect}), 
          .apb_penable_i(apb0_inst_APB_M00_interconnect_PENABLE_interconnect), 
          .apb_pready_o(apb0_inst_APB_M00_interconnect_PREADY_interconnect), 
          .apb_psel_i(apb0_inst_APB_M00_interconnect_PSELx_interconnect), 
          .apb_pslverr_o(apb0_inst_APB_M00_interconnect_PSLVERR_interconnect), 
          .apb_pwrite_i(apb0_inst_APB_M00_interconnect_PWRITE_interconnect), 
          .clk_i(pll0_inst_clkos_o_net), .int_o(uart0_inst_INT_M0_interconnect_IRQ_interconnect), 
          .rst_n_i(cpu0_inst_system_resetn_o_net), .rxd_i(rxd_i), .txd_o(txd_o));
    
endmodule

